/**
Copyright: 2024 Contrast Security, Inc
  Contact: support@contrastsecurity.com
  License: Commercial

  NOTICE: This Software and the patented inventions embodied within may only be
  used as part of Contrast Security’s commercial offerings. Even though it is
  made available through public repositories, use of this Software is subject to
  the applicable End User Licensing Agreement found at
  https://www.contrastsecurity.com/enduser-terms-0317a or as otherwise agreed
  between Contrast Security and the End User. The Software may not be reverse
  engineered, modified, repackaged, sold, redistributed or otherwise used in a
  way not consistent with the End User License Agreement.
*/
'use strict';

const Exclusion = require('./exclusion.js');
const {
  EXCLUSION_MATCH_STRATEGIES: { ALL, ONLY }
} = require('../../constants');

class UrlExclusion extends Exclusion {
  constructor(dtm) {
    super(dtm);

    this.matchStrategy = dtm.matchStrategy;
    this.urls = parseUrls(dtm.urlsList, this.name);
  }

  matchesUrl(url) {
    switch (this.matchStrategy) {
      case ONLY:
        for (const re of this.urls) {
          if (re.test(url)) {
            return true;
          }
        }
        break;
      case ALL:
        return true;
    }

    return false;
  }
}

/**
 * take urls from DTM and turn into regex
 */
function parseUrls(urls = [], name) {
  const compiled = [];
  for (const u of urls) {
    try {
      const re = new RegExp(u.trim(), 'i');
      compiled.push(re);
    } catch (e) {
      throw new Error(
        `Problem compiling expression ${u} for exclusion ${name}`
      );
    }
  }

  return compiled;
}

module.exports = UrlExclusion;
